<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
<head>
  <meta charset="utf-8" />
  <meta name="generator" content="pandoc" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes" />
  <title>Cacti – Installing Under Windows</title>
  <style type="text/css">
      code{white-space: pre-wrap;}
      span.smallcaps{font-variant: small-caps;}
      span.underline{text-decoration: underline;}
      div.column{display: inline-block; vertical-align: top; width: 50%;}
  </style>
  <style type="text/css">
a.sourceLine { display: inline-block; line-height: 1.25; }
a.sourceLine { pointer-events: none; color: inherit; text-decoration: inherit; }
a.sourceLine:empty { height: 1.2em; }
.sourceCode { overflow: visible; }
code.sourceCode { white-space: pre; position: relative; }
div.sourceCode { margin: 1em 0; }
pre.sourceCode { margin: 0; }
@media screen {
div.sourceCode { overflow: auto; }
}
@media print {
code.sourceCode { white-space: pre-wrap; }
a.sourceLine { text-indent: -1em; padding-left: 1em; }
}
pre.numberSource a.sourceLine
  { position: relative; left: -4em; }
pre.numberSource a.sourceLine::before
  { content: attr(title);
    position: relative; left: -1em; text-align: right; vertical-align: baseline;
    border: none; pointer-events: all; display: inline-block;
    -webkit-touch-callout: none; -webkit-user-select: none;
    -khtml-user-select: none; -moz-user-select: none;
    -ms-user-select: none; user-select: none;
    padding: 0 4px; width: 4em;
    color: #aaaaaa;
  }
pre.numberSource { margin-left: 3em; border-left: 1px solid #aaaaaa;  padding-left: 4px; }
div.sourceCode
  {  }
@media screen {
a.sourceLine::before { text-decoration: underline; }
}
code span.al { color: #ff0000; font-weight: bold; } /* Alert */
code span.an { color: #60a0b0; font-weight: bold; font-style: italic; } /* Annotation */
code span.at { color: #7d9029; } /* Attribute */
code span.bn { color: #40a070; } /* BaseN */
code span.bu { } /* BuiltIn */
code span.cf { color: #007020; font-weight: bold; } /* ControlFlow */
code span.ch { color: #4070a0; } /* Char */
code span.cn { color: #880000; } /* Constant */
code span.co { color: #60a0b0; font-style: italic; } /* Comment */
code span.cv { color: #60a0b0; font-weight: bold; font-style: italic; } /* CommentVar */
code span.do { color: #ba2121; font-style: italic; } /* Documentation */
code span.dt { color: #902000; } /* DataType */
code span.dv { color: #40a070; } /* DecVal */
code span.er { color: #ff0000; font-weight: bold; } /* Error */
code span.ex { } /* Extension */
code span.fl { color: #40a070; } /* Float */
code span.fu { color: #06287e; } /* Function */
code span.im { } /* Import */
code span.in { color: #60a0b0; font-weight: bold; font-style: italic; } /* Information */
code span.kw { color: #007020; font-weight: bold; } /* Keyword */
code span.op { color: #666666; } /* Operator */
code span.ot { color: #007020; } /* Other */
code span.pp { color: #bc7a00; } /* Preprocessor */
code span.sc { color: #4070a0; } /* SpecialChar */
code span.ss { color: #bb6688; } /* SpecialString */
code span.st { color: #4070a0; } /* String */
code span.va { color: #19177c; } /* Variable */
code span.vs { color: #4070a0; } /* VerbatimString */
code span.wa { color: #60a0b0; font-weight: bold; font-style: italic; } /* Warning */
  </style>
  <link rel="stylesheet" href="Cacti-Github.css" />
</head>
<body>
<h1 id="installing-under-windows">Installing Under Windows</h1>
<p>BSOD2600, one of the long term users of Cacti, provides an Installer on Windows. We recommend you use that installer for Cacti. You can obtain that installer under the Windows section of the Cacti forums. However, if you wish to install Cacti yourself, please follow the instructions below.</p>
<ol>
<li><p>(Optional) Apache - This software is optional if running Windows Internet Information Server.</p></li>
<li><p>Cacti - Install from the zip distribution and install in the web root or your choice. Many choose to install into a <code>Cacti</code> sub folder.</p></li>
<li><p>Spine - Install from the zip distribution into the <code>c:\cacti</code> directory. Make sure your <code>spine.conf.dist</code> is located in that directory as well.</p></li>
<li><p>RRDtool - Install from the Cacti website. Install it into the <code>c:\cacti</code> directory.</p></li>
<li><p>PHP X - Install into the <code>c:php</code> folder. If you choose to install into <code>c:\Program Files\php</code>, you will have to use 8.3 filenames to reference it's binaries in Cacti.</p></li>
<li><p>MySQL 5.x - Install into the default location. This is typically:</p>
<p><code>c:\Program Files\MySQL\MySQL Server X.XX</code>.</p></li>
<li><p>(Optional) Cygwin - Download and execute <code>setup.exe</code> from the Cygwin website. Keep the <code>setup.exe</code> file for later use. You will need Cygwin and its development packages for building RRDtool and spine.</p></li>
<li><p>(Optional) Net-SNMP - Install to the <code>c:net-snmp</code> directory. If you choose to use <code>c:\Program Files\net-snmp</code> you will have to use 8.3 filenames to reference its binaries in Cacti.</p></li>
</ol>
<h2 id="common-os-changes">Common OS Changes</h2>
<p>The following changes will be required regardless of your selected Webserver.</p>
<ol>
<li><p>Add the following directory to the existing Windows System <code>PATH</code> environment variable: <code>c:php</code>. The Windows path can be accessed via the Control Panel at: System -&gt; Advanced -&gt; Environment Variables -&gt; System Variables.</p></li>
<li><p>Add the following directory to a new Windows System environment variable called <code>PHPRC</code>: <code>c:\php</code>.</p></li>
<li><p>Add a new Windows System environment variable called <code>MIBDIRS</code> set it to <code>c:\php\extrasmibs</code></p></li>
<li><p>Rename the file <code>c:\php\php.ini.dist</code> to <code>php.ini</code>, and make the following changes to it:</p>
<p>Uncomment the following lines.</p>
<div class="sourceCode" id="cb1"><pre class="sourceCode ini"><code class="sourceCode ini"><a class="sourceLine" id="cb1-1" title="1"><span class="dt">extension_dir </span><span class="ot">=</span><span class="st"> c:phpext</span></a>
<a class="sourceLine" id="cb1-2" title="2"><span class="dt">extension</span><span class="ot">=</span><span class="st">php_mysql.dll</span></a>
<a class="sourceLine" id="cb1-3" title="3"><span class="dt">extension</span><span class="ot">=</span><span class="st">php_snmp.dll</span></a>
<a class="sourceLine" id="cb1-4" title="4"><span class="dt">extension</span><span class="ot">=</span><span class="st">php_sockets.dll</span></a>
<a class="sourceLine" id="cb1-5" title="5"><span class="dt">cgi.force_redirect </span><span class="ot">=</span><span class="st"> </span><span class="dv">0</span></a></code></pre></div></li>
<li><p>In earlier installation guides to PHP, they recommended moving certain DLL's to the <code>c:\winnt\system32</code> directory. If so, you will have to remove those files. Please review the PHP installation documentation for instructions on removing those files.</p></li>
<li><p>If you want to allow template importing, uncomment the following line:</p>
<div class="sourceCode" id="cb2"><pre class="sourceCode ini"><code class="sourceCode ini"><a class="sourceLine" id="cb2-1" title="1"><span class="dt">file_uploads </span><span class="ot">=</span><span class="st"> </span><span class="kw">On</span></a></code></pre></div></li>
<li><p>Give the user who will be running the scheduled task, modify rights to the <code>.index</code> file in the location pointed to by the <code>MIBDIRS</code> Windows System environment variable.</p></li>
</ol>
<h2 id="web-server-configuration">Web Server Configuration</h2>
<ol>
<li><p>Make sure you have stopped any IIS web servers before you proceed with Apache installation, or make sure Apache is configured on an alternate port.</p></li>
<li><p>If using Apache 2.x and PHP 5, then add the following lines.</p>
<div class="sourceCode" id="cb3"><pre class="sourceCode ini"><code class="sourceCode ini"><a class="sourceLine" id="cb3-1" title="1"><span class="dt">LoadModule php5_module c:\php\php5\apache2.dll</span></a>
<a class="sourceLine" id="cb3-2" title="2"><span class="dt">AddType application/x-httpd-php .php</span></a>
<a class="sourceLine" id="cb3-3" title="3"><span class="dt">DirectoryIndex index.html index.htm index.php</span></a></code></pre></div></li>
</ol>
<h2 id="iis-specific-steps">IIS Specific Steps</h2>
<ol>
<li><p>Start the Internet Information Services (IIS) Manager, right click on the Default Web Site (in most cases) and select Properties.</p></li>
<li><p>Under the Home Directory tab, select Configuration and click Add. Browse to the path of <code>php4isapi.dll</code> or <code>php5isapi.dll</code>, and type in .php as the extension. Note: if using IIS6, Enable All Verbs and Script Engine.</p></li>
<li><p>Under the ISAPI Filters tab, click Add and browse to the <code>php4isapi.dll</code> or <code>php5isapi.dll</code> file. Name the filter "php" and click OK.</p></li>
<li><p>Under the Documents tab, add <code>index.php</code> to the list.</p></li>
<li><p>If using IIS6, goto Web Service Extensions and add a new Web Service Extension. Name the extension "php", and click Add and browse to the <code>php4isapi.dll</code> or <code>php5isapi.dll</code> file, enable Set Extension status to Enable, and click OK.</p></li>
<li><p>Give the <code>IUSR_XXXX</code> and <code>IIS_WPG</code> users read &amp; execute permissions to the file <code>%windir%\system32\cmd.exe</code>. They will also need read permissions on <code>cacti_web_root/cacti</code> and it's subfolders.</p></li>
<li><p>If using IIS6, give the <code>IIS_WPG</code> user modify permissions to the folders <code>cacti_web_root/cacti/log</code> and <code>cacti_web_root/cacti/rrd</code>.</p></li>
<li><p>Completely stop and start the IIS service using the following commands:</p>
<pre class="batchfile"><code>net stop iisadmin
net start w3svc
</code></pre></li>
</ol>
<h2 id="cygwin-installation-steps-for-spine-and-rrdtool">Cygwin Installation Steps for spine and RRDtool</h2>
<ol>
<li><p>Installing a single instance of Cygwin, and using it for all applications that require it is recommended so you do not have different versions of the Cygwin dlls laying around on your system, which can cause conflicts.</p></li>
<li><p>Run <code>setup.exe</code> or <code>setup-x64.exe</code> you previously download.</p></li>
<li><p>Once you reach the portion of setup entitled Select Packages, install the following:</p>
<ul>
<li>Base (include all items)
<ul>
<li>Libs
<ul>
<li>libcairo2
<ul>
<li>libcrypt0</li>
<li>libfontconfig-common</li>
<li>libfontconfig1</li>
<li>libfreetype6</li>
<li>libgcrypt20</li>
<li>libgd3</li>
<li>libglib2.0_0</li>
<li>libmariadb-devel</li>
<li>libmysqlclient18</li>
<li>libssl1.0</li>
<li>libpango1.0_0</li>
<li>libpng16</li>
<li>libreadline7</li>
<li>zlib-devel</li>
<li>zlib0</li>
</ul></li>
<li>Devel
<ul>
<li>autoconf</li>
<li>automake</li>
<li>binutils</li>
<li>clang</li>
<li>cygwin-devel</li>
<li>gcc-core</li>
<li>gcc-g++</li>
<li>help2man</li>
<li>libargp</li>
<li>libltdl7</li>
<li>libtool</li>
<li>net-snmp-devel</li>
<li>patch</li>
<li>texinfo</li>
<li>w32api-headers</li>
<li>w32api-runtime</li>
<li>windows-default-manifest</li>
</ul></li>
<li>Web
<ul>
<li>wget</li>
</ul></li>
</ul></li>
</ul></li>
</ul></li>
<li><p>Add <code>c:\cygwin\bin</code> to your Windows System PATH environment variable.</p></li>
<li><p>Move <code>setup.exe</code> or <code>setup-x64.exe</code> to <code>c:cygwin</code> for future use. This binary is updated from time to time, so it's recommended that you update it periodically.</p></li>
</ol>
<h2 id="rrdtool-download-and-installation-instructions">RRDtool Download and Installation Instructions</h2>
<ol>
<li>TBD</li>
</ol>
<h2 id="mysql-download-and-installation-instructions">MySQL Download and Installation Instructions</h2>
<ol>
<li><p>Extract the MySQL zip file to a temp directory and run <code>setup.exe</code>.</p></li>
<li><p>Install MySQL to the default directory, or for the purposes of this manual to the <code>c:\MySQL</code> directory.</p></li>
<li><p>If running an older version of MySQL, start it by running <code>c:\MySQL\bin\win\mysqladmin.exe</code>. In more recent versions, this is not required.</p></li>
<li><p>Set a password for the root user</p>
<div class="sourceCode" id="cb5"><pre class="sourceCode sh"><code class="sourceCode bash"><a class="sourceLine" id="cb5-1" title="1"><span class="ex">shell</span><span class="op">&gt;</span> cd c:\mysql\bin</a>
<a class="sourceLine" id="cb5-2" title="2"><span class="ex">shell</span><span class="op">&gt;</span> mysqladmin --user=root password somepassword</a>
<a class="sourceLine" id="cb5-3" title="3"><span class="ex">shell</span><span class="op">&gt;</span> mysqladmin --user=root --password reload</a></code></pre></div></li>
<li><p>Create the MySQL database:</p>
<div class="sourceCode" id="cb6"><pre class="sourceCode sh"><code class="sourceCode bash"><a class="sourceLine" id="cb6-1" title="1"><span class="ex">shell</span><span class="op">&gt;</span> mysqladmin --user=root --password create cacti</a></code></pre></div></li>
<li><p>Import the default Cacti database:</p>
<div class="sourceCode" id="cb7"><pre class="sourceCode sh"><code class="sourceCode bash"><a class="sourceLine" id="cb7-1" title="1"><span class="ex">shell</span><span class="op">&gt;</span> mysql --user=root --password cacti <span class="op">&lt;</span> c:\apache2\htdocs\cacti\cacti.sql</a></code></pre></div></li>
<li><p>Create a MySQL username and password for Cacti.</p>
<div class="sourceCode" id="cb8"><pre class="sourceCode sh"><code class="sourceCode bash"><a class="sourceLine" id="cb8-1" title="1"><span class="ex">shell</span><span class="op">&gt;</span> mysql --user=root --password mysql</a></code></pre></div>
<div class="sourceCode" id="cb9"><pre class="sourceCode sql"><code class="sourceCode sql"><a class="sourceLine" id="cb9-1" title="1">MySQL<span class="op">&gt;</span> <span class="kw">GRANT</span> <span class="kw">ALL</span> <span class="kw">ON</span> cacti.<span class="op">*</span> <span class="kw">TO</span> cactiuser@localhost <span class="kw">IDENTIFIED</span> <span class="kw">BY</span> <span class="st">&#39;somepassword&#39;</span>;</a>
<a class="sourceLine" id="cb9-2" title="2">MySQL<span class="op">&gt;</span> <span class="kw">GRANT</span> <span class="kw">SELECT</span> <span class="kw">ON</span> mysql.time_zone_name <span class="kw">TO</span> cactiuser@localhost <span class="kw">IDENTIFIED</span> <span class="kw">BY</span> <span class="st">&#39;somepassword&#39;</span>;</a>
<a class="sourceLine" id="cb9-3" title="3">MySQL<span class="op">&gt;</span> <span class="kw">flush</span> <span class="kw">privileges</span>;</a></code></pre></div></li>
</ol>
<h2 id="net-snmp-installation">Net-SNMP Installation</h2>
<ol>
<li><p>If you plan to use any hosts with SNMP v2c support, and are using early versions of PHP, you must download and install the Net-SNMP libraries. Net-SNMP provides installers to install their product. However, caution must be taken if you choose to use long file names as Cacti does not see them as long file names. You will have to user 8.3 notation.</p>
<table>
<thead>
<tr class="header">
<th>Type</th>
<th>Name</th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td>Original</td>
<td><code>c:\Program Files\Net-SNMP\bin</code></td>
</tr>
<tr class="even">
<td>Becomes</td>
<td><code>c:\progra~1\net-snmp\bin</code>.</td>
</tr>
</tbody>
</table></li>
</ol>
<h2 id="cacti-spine-installation">Cacti spine Installation</h2>
<ol>
<li><p>Extract the Spine zip file to <code>c:\cacti</code> and modify the <code>spine.conf.dist</code> file to include the following statements.</p>
<div class="sourceCode" id="cb10"><pre class="sourceCode ini"><code class="sourceCode ini"><a class="sourceLine" id="cb10-1" title="1"><span class="dt">DB_Host  127.0.0.1 or hostname (not localhost)</span></a>
<a class="sourceLine" id="cb10-2" title="2"><span class="dt">DB_Database cacti</span></a>
<a class="sourceLine" id="cb10-3" title="3"><span class="dt">DB_User     cactiuser</span></a>
<a class="sourceLine" id="cb10-4" title="4"><span class="dt">DB_Password cacti</span></a>
<a class="sourceLine" id="cb10-5" title="5"><span class="dt">DB_Port     3306</span></a></code></pre></div>
<p>All other pre 0.8.6 settings are obsolete.</p></li>
<li><p>Spine now comes with a binary distribution. However, we strongly suggest that you install Cygwin and then remove all the DLL files and <code>sh.exe</code> from the <code>c:\cacti</code> directory.</p></li>
</ol>
<h2 id="finishing-your-setup">Finishing your Setup</h2>
<ol>
<li><p>Edit <code>cacti_web_root/cacti/include/config.php</code> and specify the MySQL user, password, database, and database port for your Cacti configuration.</p>
<div class="sourceCode" id="cb11"><pre class="sourceCode php"><code class="sourceCode php"><a class="sourceLine" id="cb11-1" title="1"><span class="kw">$database_default</span> = <span class="st">&quot;cacti&quot;</span><span class="ot">;</span></a>
<a class="sourceLine" id="cb11-2" title="2"><span class="kw">$database_hostname</span> = <span class="st">&quot;localhost&quot;</span><span class="ot">;</span></a>
<a class="sourceLine" id="cb11-3" title="3"><span class="kw">$database_username</span> = <span class="st">&quot;cactiuser&quot;</span><span class="ot">;</span></a>
<a class="sourceLine" id="cb11-4" title="4"><span class="kw">$database_password</span> = <span class="st">&quot;cacti&quot;</span><span class="ot">;</span></a>
<a class="sourceLine" id="cb11-5" title="5"><span class="kw">$database_port</span> = <span class="st">&quot;3306&quot;</span><span class="ot">;</span></a></code></pre></div></li>
<li><p>Point your web browser to:</p>
<p><code>http://your-server/cacti/</code></p>
<p>Log in using the username and password of admin/admin. You will be required to change this password immediately.</p></li>
<li><p>From Cacti, go to Settings -&gt; Paths and verify/udate your paths to point to the correct locations. Recommended examples are posted below. If you plan on using Spine, then it is very important that all paths include forward slashes instead of backslashes.</p>
<ul>
<li><p>PHP Binary Path:</p>
<p><code>c:/php/php.exe</code></p></li>
<li><p>RRDtool Binary Path:</p>
<p><code>c:/cacti/rrdtool.exe</code></p></li>
<li><p>SNMPGET, SNMPWALK, SNMPBULKWALK, SNMPGETNEXT Paths:</p>
<p><code>c:/progra~1/net-snmp/bin/snmpget.exe</code> <code>c:/progra~1/net-snmp/bin/snmpwalk.exe</code> <code>c:/progra~1/net-snmp/bin/snmpbulkwalk.exe</code> <code>c:/progra~1/net-snmp/bin/snmpgetnext.exe</code></p></li>
<li><p>Cacti Logfile Path:</p>
<p><code>c:/mycacti/website/cacti/log/cacti.log</code></p></li>
<li><p>Spine Path:</p>
<p><code>c:/cacti/spine.exe</code></p></li>
</ul></li>
<li><p>Click on Devices. Delete the Localhost devices as it intended for Linux environments In the upper right corner, click Add. Fill in the following information and then click Add.</p>
<ul>
<li>Description: My Windows localhost</li>
<li>Hostname: localhost</li>
<li>Device Template: Windows Device</li>
</ul></li>
<li><p>You should now be looking at the localhost device screen. Right under it's name, there should be some SNMP information listed, if not you should double check the SNMP settings on the server and firewall settings. In the upper right-hand corner, click on Create Graphs for this Host. On the following screen, select a disk partition and network interface. At the bottom of the page, click on Create.</p></li>
<li><p>Log into the user account you'll be using for the scheduled task and verify starting a Cacti polling cycle works. Do this by running the following from the command prompt:</p>
<div class="sourceCode" id="cb12"><pre class="sourceCode sh"><code class="sourceCode bash"><a class="sourceLine" id="cb12-1" title="1"><span class="ex">php</span> c:/cacti_web_root/cacti/poller.php</a></code></pre></div>
<p>The output should look something like the following:</p>
<div class="sourceCode" id="cb13"><pre class="sourceCode sh"><code class="sourceCode bash"><a class="sourceLine" id="cb13-1" title="1"><span class="ex">C</span>:<span class="dt">\&gt;</span>php c:inetpubwwwrootcactipoller.php</a>
<a class="sourceLine" id="cb13-2" title="2"><span class="ex">OK</span> u:0.00 s:0.06 r:1.32</a>
<a class="sourceLine" id="cb13-3" title="3"><span class="ex">OK</span> u:0.00 s:0.06 r:1.32</a>
<a class="sourceLine" id="cb13-4" title="4"><span class="ex">OK</span> u:0.00 s:0.16 r:2.59</a>
<a class="sourceLine" id="cb13-5" title="5"><span class="ex">OK</span> u:0.00 s:0.17 r:2.62</a>
<a class="sourceLine" id="cb13-6" title="6"><span class="ex">10/28/2005</span> 04:57:12 PM - SYSTEM STATS: Time:4.7272 Method:cmd.php Processes:1 Threads:N/A Hosts:1 HostsPerProcess:2 DataSources:4 RRDsProcessed:2</a></code></pre></div>
<p>After this has ran once, you should have <code>cacti.log</code> in <code>/cacti/log/</code> and RRDfiles in <code>/cacti/rra/</code>.</p></li>
<li><p>You are going to need to schedule a task while logged on as an Administrator. This task is required to you can run <code>poller.php</code> every 5 minutes. Make sure the Task Scheduler service is started and follow the steps below to begin.</p>
<blockquote>
<p>*<em>Note:</em> The following instructions are based on Windows XP and Windows Server 2003. You should be able to follow these instructions close enough for Windows 2000 as well.</p>
</blockquote>
<ol>
<li><p>Select Start -&gt; Settings -&gt; Control Panel and double click on Scheduled Tasks.</p></li>
<li><p>Double click on Add Scheduled Task.</p></li>
<li><p>Click Next and Browse on the following screen. Find <code>c:php</code> and select <code>php.exe</code>. Choose Daily on and click Next.</p></li>
<li><p>Click Next again without changing the time or date settings.</p></li>
<li><p>When entering a username and password make sure the user has read and write access to the following directories:</p>
<p><code>cacti_web_root/cacti/rra</code> <code>cacti_web_root/log</code></p>
<p>Make sure the user has read, write, and execute access to the following directories:</p>
<p><code>c:\php</code> <code>c:\phpsapi</code></p></li>
<li><p>Click Next and Finish to close the wizard.</p></li>
<li><p>Right click on the task you just created, and select Properties.</p></li>
<li><p>Select the Schedule tab.</p></li>
<li><p>Make sure Daily is selected and click the Advanced button.</p></li>
<li><p>Check the Repeat checkbox, set it for 5 minutes and set the duration for 24 hours.</p></li>
<li><p>Click Ok</p></li>
<li><p>In the Run textbox enter the following text making sure to use the appropriate paths.</p>
<p><code>c:\php\php.exe c:\mycacti\website\cacti\poller.php</code></p></li>
</ol>
<p>The start in box should say <code>c:\mycacti\website\cacti</code>.</p></li>
</ol>
<hr />
<p><copy>Copyright (c) 2004-2021 The Cacti Group</copy></p>
</body>
</html>
